VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "BGSCommonDialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'*********************************************************************
'Titolo: BGSCommonDialog.cls
'Autore: Giorgio Bernardi
'E-Mail: BGSoftware@hotmail.com
'Data  : Aprile 2001
'Descrizione: Classe Utile per fare a meno del controllo
'             Microsoft Common Dialog. Ho cercato di rispettare
'             per quanto possibile le parole chiavi, le propriet
'             e le funzioni del controllo M$ pur aggiungendo qualcosa
'             che ho ritenuto utile.
'Info:  Potete usare e modificare a piacimento questo codice
'IMPORTANTE:  Per usare la classe, bisogna inizializzarla attraverso
'           la funzione
'                           SetForm(YourForm as Form)
'           Dovete passare il Form sul quale solitamente avete posizionato
'           il controllo CommonDialog M$. Altrimenti dovrete utilizzare
'           le funzioni con suffisso H passando un handle valido ogni volta
'*********************************************************************

Option Explicit
'**************************************************************************
'VARIABILI PUBBLICHE DELL'OGGETTO
'**************************************************************************
'Variabili Incluse nel Controllo Microsoft Common Dialog
Public CancelError As Boolean
Public Color As Double
Public Copies As Integer
Public DefaultExt As String
Public DialogTitle As String
Public fileName As String
Public Filter As String
Public FilterIndex As Integer
Public Flags As Long
Public Font As New StdFont
Public FromPage As Integer
Public HelpCommand As Long
Public HelpContext As Long
Public HelpFile As String
Public HelpKey As Integer
Public InitDir As String
Public Max As Integer
Public MaxFileSize As Integer
Public Min As Integer
Public Orientation As prntOrientation
Public PrinterDefault As Boolean
Public Tag As String
Public ToPage As Integer

'Variabili supplementari utili per la gestione della stampa
Public PrintToFile As Boolean
Public PrintAll As Boolean
Public PrintSelection As Boolean
Public Printer As String
Public Collate As Boolean

'Variabili Private dell'Oggetto
Private ColoriPersonali As String
Private OwnerForm As Form
'**************************************************************************
'TIPI PRIVATI UTILIZZATI DALLA CLASSE
'**************************************************************************
Private Type OPENFILENAME
    lStructSize As Long
    hWnd As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    Flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Private Type COLORSTRUC
    lStructSize As Long
    hWnd As Long
    hInstance As Long
    rgbResult As Long
    lpCustColors As String
    Flags As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Private Const LF_FACESIZE = 32

Private Type LOGFONT
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(LF_FACESIZE) As Byte
End Type

Private Type FONTSTRUC
    lStructSize As Long
    hWnd As Long
    hDC As Long
    lpLogFont As Long
    iPointSize As Long
    Flags As Long
    rgbColors As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
    hInstance As Long
    lpszStyle As String
    nFontType As Integer
    MISSING_ALIGNMENT As Integer
    nSizeMin As Long
    nSizeMax As Long
End Type

Private Type DEVMODE
    dmDeviceName As String * 32
    dmSpecVersion As Integer
    dmDriverVersion As Integer
    dmSize As Integer
    dmDriverExtra As Integer
    dmFields As Long
    dmOrientation As Integer
    dmPaperSize As Integer
    dmPaperLength As Integer
    dmPaperWidth As Integer
    dmScale As Integer
    dmCopies As Integer
    dmDefaultSource As Integer
    dmPrintQuality As Integer
    dmColor As Integer
    dmDuplex As Integer
    dmYResolution As Integer
    dmTTOption As Integer
    dmCollate As Integer
    dmFormName As String * 32
    dmUnusedPadding As Integer
    dmBitsPerPel As Integer
    dmPelsWidth As Long
    dmPelsHeight As Long
    dmDisplayFlags As Long
    dmDisplayFreq As Long
End Type

Private Type PRINTDLGSTRUC
    lStructSize As Long
    hWnd As Long
    hDevMode As Long
    hDevNames As Long
    hDC As Long
    Flags As Long
    nFromPage As Integer
    nToPage As Integer
    nMinPage As Integer
    nMaxPage As Integer
    nCopies As Integer
    hInstance As Long
    lCustData As Long
    lpfnPrintHook As Long
    lpfnSetupHook As Long
    lpPrintTemplateName As String
    lpSetupTemplateName As String
    hPrintTemplate As Long
    hSetupTemplate As Long
End Type

'Tipi
Public Enum prntOrientation
    cdlPortrait = 1
    cdlLandscape = 2
End Enum

'**************************************************************************
'DICHIARAZIONE FUNZIONI PRIVATE UTILIZZATE DALLA CLASSE
'**************************************************************************
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function PrintDlg Lib "comdlg32.dll" Alias "PrintDlgA" (pPrintdlg As PRINTDLGSTRUC) As Long
Private Declare Function ChooseColor Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As COLORSTRUC) As Long
Private Declare Function ChooseFont Lib "comdlg32.dll" Alias "ChooseFontA" (pChoosefont As FONTSTRUC) As Long
Private Declare Function GlobalAlloc Lib "Kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalLock Lib "Kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalUnlock Lib "Kernel32" (ByVal hMem As Long) As Long
Private Declare Sub CopyMemory Lib "Kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Private Declare Function WinHelp Lib "user32" Alias "WinHelpA" (ByVal hWnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, ByVal dwData As Long) As Long

'**************************************************************************
'FUNZIONI PUBBLICHE DELLA CLASSE (presenti anche nel controllo Microsoft)
'**************************************************************************
Public Function ShowOpen() As String
    ShowOpen = ShowOpenH(OwnerForm.hWnd)
End Function

Public Function ShowSave() As String
    ShowSave = ShowSaveH(OwnerForm.hWnd)
End Function

Public Function ShowColor() As Long
    ShowColor = ShowColorH(OwnerForm.hWnd)
End Function

Public Function ShowFont() As Boolean
    ShowFont = ShowFontH(OwnerForm.hWnd)
End Function

Public Function ShowHelp() As Boolean
    ShowHelp = ShowHelpH(OwnerForm.hWnd)
End Function

Public Function ShowPrint() As Boolean
    ShowPrint = ShowPrintH(OwnerForm.hWnd)
End Function

Public Sub SetForm(YourForm As Form)
    Set OwnerForm = YourForm
End Sub
'**************************************************************************
'Propriet della classe
'**************************************************************************
Public Property Let Action(Dialog As Integer)
Select Case Dialog
    Case 1
        Call ShowOpen
    Case 2
        Call ShowSave
    Case 3
        Call ShowColor
    Case 4
        Call ShowFont
    Case 5
        Call ShowPrint
    Case 6
        Call ShowHelp
End Select
End Property

Public Property Let FontBold(Boldness As Boolean)
    Font.Bold = Boldness
End Property

Public Property Get FontBold() As Boolean
    FontBold = Font.Bold
End Property

Public Property Let FontItalic(Italic As Boolean)
    Font.Italic = Italic
End Property

Public Property Get FontItalic() As Boolean
    FontItalic = Font.Italic
End Property

Public Property Let FontName(Name As String)
    Font.Name = Name
End Property

Public Property Get FontName() As String
    FontName = Font.Name
End Property

Public Property Let FontSize(Size As Currency)
    Font.Size = Size
End Property

Public Property Get FontSize() As Currency
    FontSize = Font.Size
End Property

Public Property Let FontStrikeThru(Strike As Boolean)
    Font.Strikethrough = Strike
End Property

Public Property Get FontStrikeThru() As Boolean
    FontStrikeThru = Font.Strikethrough
End Property

Public Property Let FontUnderline(Underline As Boolean)
    Font.Underline = Underline
End Property

Public Property Get FontUnderline() As Boolean
    FontUnderline = Font.Underline
End Property

'**************************************************************************
'FUNZIONI PRIVATE CHE RICHIEDONO UN HANDLE PER FUNZIONARE
'**************************************************************************
Private Function ShowOpenH(hWnd As Long) As String
    fileName = FileDialog(hWnd, True)
    ShowOpenH = fileName
End Function

Private Function ShowSaveH(hWnd As Long) As String
    fileName = FileDialog(hWnd, False)
    ShowSaveH = fileName
End Function

Private Function ShowColorH(hWnd As Long) As Long
Dim X As Long
Dim tempColorStruc As COLORSTRUC

    With tempColorStruc
        .lStructSize = Len(tempColorStruc)
        .hWnd = hWnd
        .hInstance = App.hInstance
        .Flags = Flags
        .rgbResult = Color
        .lpCustColors = ColoriPersonali
        X = ChooseColor(tempColorStruc)
        ColoriPersonali = .lpCustColors
    End With

    If X = 0 Then
        ShowColorH = Color
    Else
        Color = tempColorStruc.rgbResult
        ShowColorH = Color
    End If
End Function

Private Function ShowFontH(hWnd As Long) As Boolean
Dim tempLogFont As LOGFONT
Dim tempFontStruct As FONTSTRUC
Dim lLogFontAddress As Long
Dim lMemHandle As Long
Dim d As Integer

With tempLogFont
    If Font.Bold Then .lfWeight = 700
    If Font.Italic Then .lfItalic = 1
    If Font.Underline Then .lfUnderline = 1
    If Font.Strikethrough Then .lfStrikeOut = 1
    'Imposto il Nome del Font (non so per perch non funziona!!)
    For d = 0 To Len(Font.Name) - 1
        tempLogFont.lfFaceName(d) = CByte(Asc(Mid(Font.Name, d + 1, 1)))
    Next d
End With

tempFontStruct.lStructSize = Len(tempFontStruct)
lMemHandle = GlobalAlloc(&H2 Or &H40, Len(tempLogFont))

If lMemHandle = 0 Then
    ShowFontH = False
    Exit Function
End If

lLogFontAddress = GlobalLock(lMemHandle)

If lLogFontAddress = 0 Then
    ShowFontH = False
    Exit Function
End If

CopyMemory ByVal lLogFontAddress, tempLogFont, Len(tempLogFont)

With tempFontStruct
    .lpLogFont = lLogFontAddress
    .iPointSize = Font.Size * 10
    .nSizeMax = Max
    .nSizeMin = Min
    .hInstance = App.hInstance
    .Flags = Flags
    .rgbColors = Color
End With

If ChooseFont(tempFontStruct) = 1 Then
    CopyMemory tempLogFont, ByVal lLogFontAddress, Len(tempLogFont)
    With tempLogFont
        If .lfWeight >= 700 Then Font.Bold = True Else Font.Bold = False
        If .lfItalic = 0 Then Font.Italic = False Else Font.Italic = True
        If (Flags And &H100) = &H100 Then   'Solo se sono stati visualizzati gli effetti grafici
            If .lfUnderline = 1 Then Font.Underline = True Else Font.Underline = False
            If .lfStrikeOut = 1 Then Font.Strikethrough = True Else Font.Strikethrough = False
            Color = tempFontStruct.rgbColors
        End If
        If (tempFontStruct.Flags And &H80000) <> &H80000 Then
            Font.Name = BytesToString(tempLogFont.lfFaceName())
        End If
        Font.Size = CLng(tempFontStruct.iPointSize / 10)
    End With
    ShowFontH = True
Else
    ShowFontH = False
End If
End Function

Private Function ShowHelpH(hWnd As Long) As Boolean
    ShowHelpH = CBool(WinHelp(hWnd, HelpFile, HelpCommand, HelpContext))
End Function

Private Function ShowPrintH(hWnd As Long) As Boolean
Dim DM As DEVMODE
Dim PD As PRINTDLGSTRUC
Dim lpDM As Long

PD.lStructSize = Len(PD)
PD.hWnd = hWnd
PD.hDevMode = 0
PD.hDevNames = 0
PD.hDC = 0
PD.Flags = Flags
PD.nFromPage = FromPage
PD.nToPage = ToPage
PD.nMinPage = Min
PD.nMaxPage = Max
PD.nCopies = Copies

If PrintDlg(PD) Then
    lpDM = GlobalLock(PD.hDevMode)
    CopyMemory DM, ByVal lpDM, Len(DM)
    lpDM = GlobalUnlock(PD.hDevMode)
    
    Printer = Left$(DM.dmDeviceName, InStr(DM.dmDeviceName, Chr(0)) - 1)
    'Valori Di Default
    PrintAll = True
    PrintSelection = False
    If PD.Flags And &H20 Then PrintToFile = True Else PrintToFile = False
    If DM.dmCollate = 1 Then Collate = True Else Collate = False
    If PD.Flags And &H2 Then
        PrintAll = False
        PrintSelection = False
        FromPage = PD.nFromPage
        ToPage = PD.nToPage
    End If
    If PD.Flags And &H1 Then
        PrintAll = False
        PrintSelection = True
    End If
    If PD.nCopies = 1 Then
        Copies = DM.dmCopies
    End If
    Orientation = DM.dmOrientation
    ShowPrintH = True
Else
    ShowPrintH = False
End If
End Function

'**************************************************************************
'FUNZIONI PRIVATE UTILIZZATE DALLA CLASSE
'**************************************************************************
Private Function FileDialog(hWnd As Long, Apri As Boolean) As String
    Dim X As Long
    Dim tempOpFileName As OPENFILENAME
    Dim tempFile As String
    
    With tempOpFileName
        .lStructSize = Len(tempOpFileName)
        .hWnd = hWnd
        .lpstrTitle = DialogTitle
        .lpstrFile = fileName & String$(MaxFileSize - Len(fileName), 0)
        .nMaxFile = MaxFileSize
        .lpstrFileTitle = String$(MaxFileSize, 0)
        .nMaxFileTitle = MaxFileSize
        .lpstrFilter = changeChar(Filter, 124, 0)
        .nFilterIndex = FilterIndex
        .lpstrInitialDir = InitDir
        If DefaultExt <> "" Then
            .lpstrDefExt = DefaultExt
        Else
            .lpstrDefExt = "NOEXT"
        End If
        .Flags = Flags
    End With
    
    If Apri Then
        X = GetOpenFileName(tempOpFileName)
    Else
        X = GetSaveFileName(tempOpFileName)
    End If
    
    If X <> 0 Then
        If InStr(tempOpFileName.lpstrFile, Chr$(0) & Chr$(0)) > 0 Then
            tempFile = Left$(tempOpFileName.lpstrFile, InStr(tempOpFileName.lpstrFile, Chr$(0) & Chr$(0)) - 1)
        End If
        If Not Apri And tempOpFileName.lpstrDefExt = "NOEXT" And Len(tempFile) > 6 Then
            If Right(tempFile, 6) = ".NOEXT" Then tempFile = Left(tempFile, Len(tempFile) - 6)
        End If
    Else
        tempFile = ""
    End If
    
    FilterIndex = tempOpFileName.nFilterIndex
    FileDialog = tempFile

End Function

Private Function changeChar(ByVal Str As String, oldChr As Integer, newChr As Integer) As String
Dim d As Long
Dim tempPos As Long
Dim lenStr As Long

If Str = "" Then
    changeChar = ""
Else
    lenStr = Len(Str)
    tempPos = InStr(1, Str, Chr(oldChr), vbBinaryCompare)
    Do While tempPos
        Str = Left(Str, tempPos - 1) & Chr(newChr) & Right(Str, lenStr - tempPos)
        tempPos = InStr(tempPos, Str, Chr(oldChr), vbBinaryCompare)
    Loop
    changeChar = Str
End If
End Function

Private Function BytesToString(ByteArray() As Byte) As String
Dim tempString As String
Dim d As Long

For d = LBound(ByteArray) To UBound(ByteArray)
    If ByteArray(d) = 0 Then
        Exit For
    Else
        tempString = tempString & Chr$(ByteArray(d))
    End If
Next d

BytesToString = tempString
End Function

Private Sub Class_Initialize()
'Inizializzazione di alcune variabili
ColoriPersonali = String$(64, 0)
Copies = 1
Font.Name = "Arial"
Font.Size = 10
MaxFileSize = 260
Orientation = cdlPortrait
PrinterDefault = True
PrintAll = True
End Sub

