Attribute VB_Name = "MainModulo"
Public fileName As String           'Nome dell'archivio
Public InfoFile As String           'Nome del file Opzione
Public AttesaIsVisible As Boolean
Public SqlInfos As InfoRecord

Private Type PrgRecord
    NomeProgramma As String * 30
    Versione As String * 20
    Disco As String * 25
    Info As String * 255
    Percorso As String * 255
End Type

Public Type InfoRecord
    Campi As String         'SELECT Campi
    Ordine As String        'ORDER BY Ordine
    Requisiti As String     'WHERE Requisiti
End Type

'********************************************************************
'               Macro-Operazioni
'********************************************************************

Public Function NuovaCompilation(ByVal File As String) As Boolean
    'Azzeramento File e Creazione Nuovo DataBase
    NuovaCompilation = CreateNewDatabase(File)
    If NuovaCompilation Then
        RipulisciCampi
    Else
        Call MsgBox(Err_CreatingFile, vbCritical)
    End If
End Function


Public Sub AggiungiCartella(ByRef LenBasePath As Integer, ByVal CurPath As String, ByRef NomeDisco As String, NumRicorsione As Integer, Opzioni() As Boolean)
'MaxIterazione=0    =>  Procedi sempre fino in fondo!
'La procedura lavora per Ricorsione!
'Mi fermo con NumRicorsione=0. Per non fermarsi passare NumRicorsione
'gi MINORE di 0

'Controllo se devo proseguire
DoEvents
If Not AttesaIsVisible Then Exit Sub

Dim CartelleInterne() As String     'Cartelle nella cartella corrente
Dim ExeFiles() As String            'Files Exe nella cartella
Dim tempFile As String
Dim fileFound As Boolean            'Indica se ho trovato un file
Dim CurDato As PrgRecord

ReDim CartelleInterne(-1 To -1)
ReDim ExeFiles(-1 To -1)

'Richiedo il primo file
'30 indica la somma di tutti i possibili attributi
tempFile = Dir$(CurPath & "*.*", 30)
Do While tempFile <> ""         'Continuo fino a che Dir$ mi passa un file
    If tempFile <> "." And tempFile <> ".." Then
        If (GetAttr(CurPath & tempFile) And vbDirectory) = vbDirectory Then ' una cartella
            Call AddToArray(CartelleInterne, tempFile)
        ElseIf (tempFile Like "*.ex?") And (Opzioni(1) = True) Then  'se  un file exe
            Call AddToArray(ExeFiles, tempFile)
        Else    'E' un altro file
            fileFound = True
        End If
    End If
    tempFile = Dir$          'Richiedo un altro file
Loop




'Devo fare qualche cosa se c' un file nella cartella
'Se non c' ricorro e basta
If fileFound Or UBound(ExeFiles) > -1 Then
    'Scelgo cosa devo fare
    'Azzeramento
    CurDato.Disco = NomeDisco & String(30, 0)
    'CurDato.Info = ""
    'CurDato.NomeProgramma = ""
    CurDato.Percorso = Right(CurPath, Len(CurPath) - LenBasePath) & String(255, 0)
    'CurDato.Versione = string(25,0)
    
    If Opzioni(1) And UBound(ExeFiles) > -1 Then 'Devo cercare info da Exe
        For d = 0 To UBound(ExeFiles)
            'I Files Setup... li salto tanto non hanno senso
            If Not (ExeFiles(d) Like "setup*") Then
                'Cerco informazioni da questo
                CurDato.NomeProgramma = getExeDllAttribute(CurPath & ExeFiles(d), ProductName) & String(30, 0)
                If Left(CurDato.NomeProgramma, 1) <> Chr(0) Then 'Continuo
                    CurDato.Versione = getExeDllAttribute(CurPath & ExeFiles(d), ProductVersion) & String(20, 0)
                    If Left(CurDato.Versione, 1) = Chr(0) Then CurDato.Versione = getExeDllAttribute(CurPath & ExeFiles(d), FileVersion) & String(20, 0)
                    CurDato.Info = getExeDllAttribute(CurPath & ExeFiles(d), Description) & String(30, 0)
                    CurDato.Info = CurDato.Info & IIf(Left(CurDato.Info, 1) = Chr(0), "", ";") & getExeDllAttribute(CurPath & ExeFiles(d), Comments) & String(30, 0)
                    'Ho ottenuto le informazioni
                    GoTo SetNewElement
                End If
            End If
        Next d
    End If
    
    Dim NomeDellaCartella As String
    NomeDellaCartella = getFileName(Left(CurPath, Len(CurPath) - 1))
    
    'Se arrivo qui NON ho ottenuto le informazioni che mi interessavano
    If Opzioni(4) Then  'Devo cercare anche la versione nel nome di cartella
        Dim FoundVersion As Boolean
        'Questo Ciclo cerca la versione
        For d = 1 To Len(NomeDellaCartella)
            If Val(Right(NomeDellaCartella, d)) > 0 Then
                FoundVersion = True
            Else
                'Se l'avevo trovato prima mi fermo e utilizzo quello di prima
                If FoundVersion Then
                    CurDato.Versione = Right(NomeDellaCartella, d - 1) & String(30, 0)
                    NomeDellaCartella = Left(NomeDellaCartella, Len(NomeDellaCartella) - d + 1)
                End If
                Exit For
            End If
        Next d
    End If
    
    'Ora cerco i "_"
    If Opzioni(2) Then
        For d = 2 To Len(NomeDellaCartella) - 1
            If Mid(NomeDellaCartella, d, 1) = "_" Then Mid(NomeDellaCartella, d, 1) = " "
        Next d
    End If
    
    'Ora cerco le maiuscole
    If Opzioni(3) Then
        Dim CharL As String
        d = 2
        Do
            CharL = Asc(Mid(NomeDellaCartella, d, 1))
            If (CharL >= 65 And CharL <= 90) And (Mid(NomeDellaCartella, d - 1, 1) <> " ") Then 'maiuscolo e non preceduto da Spazio
                NomeDellaCartella = Left(NomeDellaCartella, d - 1) & " " & Right(NomeDellaCartella, Len(NomeDellaCartella) - d + 1)
                d = d + 1
            End If
            d = d + 1
        Loop Until (d > Len(NomeDellaCartella))
     End If
     'Controllo l'ultimo carattere
     If Right(NomeProgramma, 1) = "_" Then NomeProgramma = Left(NomeProgramma, Len(NomeProgramma) - 1)
          
     'Aggiunta dato
     CurDato.NomeProgramma = NomeDellaCartella & String(30, 0)
     
SetNewElement:
    'Aggiungo il record
    Call AggiungiRecordConDati(CurDato)
    
    If Opzioni(0) Then Exit Sub 'Mi fermo appena trovo un programma
End If

If NumRicorsione <> 1 And UBound(CartelleInterne) > -1 Then
'Devo andare in ricorsione
    For d = 0 To UBound(CartelleInterne)
        Call AggiungiCartella(LenBasePath, CurPath & CartelleInterne(d) & "\", NomeDisco, NumRicorsione - 1, Opzioni)
        'Controllo se devo proseguire
        DoEvents
        If Not AttesaIsVisible Then Exit Sub
    Next d
End If
End Sub

Private Sub AggiungiRecordConDati(ByRef Dati As PrgRecord)
'Aggiungo
F_Principale.D_Infos.Recordset.AddNew   'Aggiungo il nuovo record
'Riempio i Campi
F_Principale.T_PrEditor(0).Text = getValueFromConsString(Dati.NomeProgramma)
F_Principale.T_PrEditor(1).Text = getValueFromConsString(Dati.Versione)
F_Principale.T_PrEditor(2).Text = getValueFromConsString(Dati.Disco)
F_Principale.T_PrEditor(3).Text = getValueFromConsString(Dati.Info)
F_Principale.T_PrEditor(4).Text = getValueFromConsString(Dati.Percorso)
'Aggiorno
Call AggiornaRecord(False)
End Sub

Public Sub TrovaOccorrenza()
F_Search.OKAnswer = False
'Richiesta opzioni
Call F_Search.Show(1, F_Principale)
If F_Search.OKAnswer Then
    F_Principale.D_Infos.Recordset.FindFirst (F_Search.LastSQLSearchString)
    If F_Principale.D_Infos.Recordset.NoMatch Then Call MsgBox(Infos(5), vbInformation)
End If
End Sub

Public Sub RimuoviFiltro()
    SqlInfos.Requisiti = ""
    Call RefreshRecord
End Sub

Public Sub FiltraRecord()
F_Search.OKAnswer = False
'Richiesta opzioni
F_Search.IsFiltering = True
Call F_Search.Show(1, F_Principale)
F_Search.IsFiltering = False

If F_Search.OKAnswer Then Call RefreshRecord
End Sub

Public Sub CaricaFAttesa()
    Load F_Attesa
    F_Attesa.L_Caption.Caption = Infos(3)
    F_Attesa.C_Termina.Caption = Infos(4)
    F_Attesa.Show
End Sub
'********************************************************************
'               Importa - Esporta
'********************************************************************

Public Sub EsportaCSV(ByRef filePath As String, Optional Campo0 As Boolean = True, Optional Campo1 As Boolean = True, Optional Campo2 As Boolean = True, Optional Campo3 As Boolean = True, Optional Campo4 As Boolean = True)
On Error GoTo err_Export
Open filePath For Output As #1
Dim tempStr As String

If Not NessunElemento Then
    Call RecordMove(0)
    Do
        tempStr = IIf(Campo0, IIf(InStr(1, F_Principale.T_PrEditor(0).Text, Chr(32), vbBinaryCompare) Or InStr(1, F_Principale.T_PrEditor(0).Text, ",", vbBinaryCompare), """", "") & F_Principale.T_PrEditor(0).Text & IIf(InStr(1, F_Principale.T_PrEditor(0).Text, Chr(32), vbBinaryCompare) Or InStr(1, F_Principale.T_PrEditor(0).Text, ",", vbBinaryCompare), """", "") & ",", "") & _
                  IIf(Campo0, IIf(InStr(1, F_Principale.T_PrEditor(1).Text, Chr(32), vbBinaryCompare) Or InStr(1, F_Principale.T_PrEditor(1).Text, ",", vbBinaryCompare), """", "") & F_Principale.T_PrEditor(1).Text & IIf(InStr(1, F_Principale.T_PrEditor(1).Text, Chr(32), vbBinaryCompare) Or InStr(1, F_Principale.T_PrEditor(1).Text, ",", vbBinaryCompare), """", "") & ",", "") & _
                  IIf(Campo0, IIf(InStr(1, F_Principale.T_PrEditor(2).Text, Chr(32), vbBinaryCompare) Or InStr(1, F_Principale.T_PrEditor(2).Text, ",", vbBinaryCompare), """", "") & F_Principale.T_PrEditor(2).Text & IIf(InStr(1, F_Principale.T_PrEditor(2).Text, Chr(32), vbBinaryCompare) Or InStr(1, F_Principale.T_PrEditor(2).Text, ",", vbBinaryCompare), """", "") & ",", "") & _
                  IIf(Campo0, IIf(InStr(1, F_Principale.T_PrEditor(3).Text, Chr(32), vbBinaryCompare) Or InStr(1, F_Principale.T_PrEditor(3).Text, ",", vbBinaryCompare), """", "") & F_Principale.T_PrEditor(3).Text & IIf(InStr(1, F_Principale.T_PrEditor(3).Text, Chr(32), vbBinaryCompare) Or InStr(1, F_Principale.T_PrEditor(3).Text, ",", vbBinaryCompare), """", "") & ",", "") & _
                  IIf(Campo0, IIf(InStr(1, F_Principale.T_PrEditor(4).Text, Chr(32), vbBinaryCompare) Or InStr(1, F_Principale.T_PrEditor(4).Text, ",", vbBinaryCompare), """", "") & F_Principale.T_PrEditor(4).Text & IIf(InStr(1, F_Principale.T_PrEditor(4).Text, Chr(32), vbBinaryCompare) Or InStr(1, F_Principale.T_PrEditor(4).Text, ",", vbBinaryCompare), """", "") & ",", "")
        
        Print #1, Left(tempStr, Len(tempStr) - 1)
        DoEvents
    Loop While (RecordMove(2) And AttesaIsVisible)
End If

Close
Exit Sub
err_Export:
Close
Call MsgBox(Errors(10) & vbCrLf & err.Description, vbCritical)
err.Clear
End Sub

Public Sub EsportaTAB(ByRef filePath As String, Optional Campo0 As Boolean = True, Optional Campo1 As Boolean = True, Optional Campo2 As Boolean = True, Optional Campo3 As Boolean = True, Optional Campo4 As Boolean = True)
On Error GoTo err_Export
Open filePath For Output As #1
Dim tempStr As String

If Not NessunElemento Then
    Call RecordMove(0)
    Do
        tempStr = IIf(Campo0, F_Principale.T_PrEditor(0) & vbTab, "") & _
                IIf(Campo1, F_Principale.T_PrEditor(1) & vbTab, "") & _
                IIf(Campo2, F_Principale.T_PrEditor(2) & vbTab, "") & _
                IIf(Campo3, F_Principale.T_PrEditor(3) & vbTab, "") & _
                IIf(Campo4, F_Principale.T_PrEditor(4) & vbTab, "")
        'tempStr = Left(tempStr, Len(tempStr) - 1) 'Tolgo l'ultimo vbtab
        Print #1, Left(tempStr, Len(tempStr) - 1)
        DoEvents
    Loop While (RecordMove(2) And AttesaIsVisible)
End If

Close
Exit Sub
err_Export:
Close
Call MsgBox(Errors(10) & vbCrLf & err.Description, vbCritical)
err.Clear
End Sub

Public Sub EsportaPMF(ByRef filePath As String)
On Error GoTo err_Export

    F_Principale.D_Infos.Database.Close
    'DoEvents
    Call FileCopy(fileName, filePath)
    'DoEvents
    F_Principale.D_Infos.DatabaseName = fileName
    F_Principale.D_Infos.Refresh
    'FileName = tempFile

Exit Sub
err_Export:
Call MsgBox(Errors(10) & vbCrLf & err.Description, vbCritical)
err.Clear
End Sub

Public Sub EsportaTXT(ByRef filePath As String)
On Error GoTo err_Export
Open filePath For Output As #1
Dim d As Integer

If Not NessunElemento Then
    Call RecordMove(0)
    With F_Opzioni
        'Titolo
        If Trim(.T_EsportaTop.Text) <> "" Then Print #1, .T_EsportaTop.Text & vbCrLf
        'Campi
        Do
            For d = 0 To 4
                If .Ch_Campo(d).Value Then _
                    Print #1, .T_NomeCampoSpEsporta(d).Text & F_Principale.T_PrEditor(d)
                If d = 4 Then Print #1, ""
            Next d
            DoEvents
        Loop While (RecordMove(2) And AttesaIsVisible)
    End With
End If

Close
Exit Sub
err_Export:
Close
Call MsgBox(Errors(10) & vbCrLf & err.Description, vbCritical)
err.Clear
End Sub

Public Sub EsportaHTML(ByRef filePath As String)
On Error GoTo err_Export
Open filePath For Output As #1
'Dim tempStr As String

'Intestazione del File
Print #1, "<HTML>" & vbCrLf & _
          "<HEAD>" & vbCrLf & _
          "<meta name=""GENERATOR"" content=""Program Manager By BGSoftware"">" & vbCrLf & _
          "<TITLE>Archivio di Program Manager: " & getFileName(filePath, True) & "</TITLE>" & vbCrLf & _
          "</HEAD>" & vbCrLf & F_Opzioni.T_HtmlHead.Text

If Not NessunElemento Then
    Call RecordMove(0)
    With F_Opzioni
        'Titolo
        Print #1, "<center><a name=""TopPage"">" & .T_EsportaTop.Text & "</center>" & vbCrLf
        'Campi
        Do
            For d = 0 To 4
                If .Ch_Campo(d).Value Then _
                    Print #1, .T_NomeCampoSpEsporta(d).Text & IIf(d = 0, "<b>", "") & F_Principale.T_PrEditor(d) & IIf(d = 0, "</b>", "") & IIf(d = 4, " <a href=""" & F_Principale.T_PrEditor(4) & """ target=""_new"">=></a>", "") & "<br>"
                If d = 4 Then _
                    Print #1, "<Font size=-2><a href=""#TopPage"">Top</a></font></BR><BR>"
            Next d
            DoEvents
        Loop While (RecordMove(2) And AttesaIsVisible)
    End With
End If

Print #1, "</font></body></html>"

Close
Exit Sub
err_Export:
Close
Call MsgBox(Errors(10) & vbCrLf & err.Description, vbCritical)
err.Clear
End Sub

Public Sub ImportaCSV(ByRef filePath As String)
On Error GoTo err_Import
Open filePath For Input As #1
Dim CurDato As PrgRecord

Do Until (EOF(1) Or Not AttesaIsVisible)
    Input #1, CurDato.NomeProgramma, CurDato.Versione, CurDato.Disco, CurDato.Info, CurDato.Percorso
    If Trim(CurDato.NomeProgramma) = "" Or Trim(CurDato.Disco) = "" Then GoTo err_Import
    'Aggiungo il record
    Call AggiungiRecordConDati(CurDato)
    DoEvents
Loop

Close
Exit Sub
err_Import:
Close
Call MsgBox(Errors(10) & vbCrLf & err.Description, vbCritical)
err.Clear
End Sub

Public Sub ImportaTAB(ByRef filePath As String)
On Error GoTo err_Import
Open filePath For Input As #1
Dim CurDato As PrgRecord
Dim tempStr As String

'tempStr = ContenutoFileTxt(filePath)

Do Until (EOF(1) Or Not AttesaIsVisible)
    Line Input #1, tempStr
    
    c = InStr(1, tempStr, Chr(9), vbBinaryCompare)
    CurDato.NomeProgramma = Left(tempStr, c - 1)
    tempStr = Right(tempStr, Len(tempStr) - c)
    
    c = InStr(1, tempStr, Chr(9), vbBinaryCompare)
    CurDato.Versione = Left(tempStr, c - 1)
    tempStr = Right(tempStr, Len(tempStr) - c)
    
    c = InStr(1, tempStr, Chr(9), vbBinaryCompare)
    CurDato.Disco = Left(tempStr, c - 1)
    tempStr = Right(tempStr, Len(tempStr) - c)
    
    c = InStr(1, tempStr, Chr(9), vbBinaryCompare)
    CurDato.Info = Left(tempStr, c - 1)
    tempStr = Right(tempStr, Len(tempStr) - c)
    
    CurDato.Percorso = tempStr
    
    If CurDato.NomeProgramma = "" Or CurDato.Disco = "" Then GoTo err_Import
    'Aggiungo il record
    Call AggiungiRecordConDati(CurDato)
    DoEvents
Loop

Close
Exit Sub
err_Import:
Close
Call MsgBox(Errors(10) & vbCrLf & err.Description, vbCritical)
err.Clear
End Sub

Public Sub StampaTXT(Stampante As PrinterCls)
On Error GoTo err_Print
Dim d As Integer
Dim DaStampare As String

If Not NessunElemento Then
    Stampante.DocumentStart
    Call RecordMove(0)
    With F_Opzioni
        'Titolo
        Stampante.Align = AlignCenter
        If Trim(.T_EsportaTop.Text) <> "" Then Call Stampante.DocumentPrintText(.T_EsportaTop.Text & vbCrLf & " ")
        'Campi
        Stampante.Align = AlignLeft
        Do
            For d = 0 To 4
                If .Ch_Campo(d).Value Then _
                    DaStampare = DaStampare & .T_NomeCampoSpEsporta(d).Text & F_Principale.T_PrEditor(d) & vbCrLf
                If d = 4 Then DaStampare = DaStampare & vbCrLf
            Next d
            DoEvents
        Loop While (RecordMove(2) And AttesaIsVisible)
        Stampante.DocumentPrintText (DaStampare)
    End With
End If

Stampante.DocumentEnd
Exit Sub
err_Print:
Stampante.DocumentEnd
Call MsgBox(Errors(13) & vbCrLf & err.Description, vbCritical)
err.Clear
End Sub

'********************************************************************
'               Micro-Operazioni sui record
'********************************************************************
Public Sub AggiungiRecord()
    Call AbilitaCampiEPulsanti(True)
    F_Principale.T_PrEditor(0).SetFocus
    F_Principale.D_Infos.Recordset.AddNew
End Sub

Public Sub ModificaRecord()
    Call AbilitaCampiEPulsanti(True)
    F_Principale.T_PrEditor(0).SetFocus
    F_Principale.D_Infos.Recordset.Edit
    If F_Principale.Cm_Opz_AutoDiskNavigator.Checked Then Call F_Principale.Cm_PathToNavigator_Click
End Sub

Public Sub NextRecord(Optional Modifica As Boolean = False)
    
    'Se devo Procedere al prossimo
    If Not F_Principale.Cm_Opz_AutoNext.Checked Then Call AbilitaCampiEPulsanti(False): Exit Sub
    F_Principale.T_PrEditor(0).SetFocus
    
    If Modifica Then    'Se lo devo modificare
        F_Principale.Cm_Bar_Move_Click (2)
        F_Principale.D_Infos.Recordset.Edit
        If F_Principale.Cm_Opz_AutoDiskNavigator.Checked Then Call F_Principale.Cm_PathToNavigator_Click
    Else    'se lo devo aggiungere
        F_Principale.D_Infos.Recordset.AddNew   'Aggiungo il nuovo record
    End If
End Sub

Public Function AggiornaRecord(Optional Controllo As Boolean = True) As Boolean
With F_Principale
    'Controllo Campi Obbligatori
    If Controllo Then If Trim(.T_PrEditor(0).Text) = "" Or Trim(.T_PrEditor(2).Text) = "" Then Exit Function
    
    'Aggiornamento
    .D_Infos.Recordset.Update
    .D_Infos.Recordset.Bookmark = .D_Infos.Recordset.lastModified
    '.D_Infos.Refresh
    '.D_Infos.Recordset.MoveFirst
    'Call AbilitaCampiEPulsanti(False)
    AggiornaRecord = True
End With
End Function

Public Function RecordMove(Index As Integer) As Boolean
'Movimento all'interno dei records
'0= First
'1= Previous
'2= Next
'3= Last
If NessunElemento Then Exit Function
With F_Principale.D_Infos
    Select Case Index
        Case 0
            .Recordset.MoveFirst
        Case 1
            If .Recordset.AbsolutePosition = 0 Then Exit Function
            .Recordset.MovePrevious
        Case 2
            .Recordset.MoveNext
            If .Recordset.EOF Then .Recordset.MoveLast: Exit Function
        Case 3
            .Recordset.MoveLast
    End Select
End With
RecordMove = True
End Function

Public Function NessunElemento() As Boolean
    If F_Principale.D_Infos.Recordset.RecordCount <= 0 Then _
        NessunElemento = True
End Function

Public Sub RimuoviRecord()
With F_Principale
    'On Error Resume Next
    'Aggiornamento
    Call RipulisciCampi
    .D_Infos.Recordset.Delete
    .D_Infos.Refresh
    .D_Infos.Recordset.Bookmark = .D_Infos.Recordset.lastModified
End With
End Sub

Public Sub UndoRecord()
With F_Principale
    'On Error Resume Next
    'Aggiornamento
    Call RipulisciCampi
    .D_Infos.Recordset.CancelUpdate
    .D_Infos.Recordset.Bookmark = .D_Infos.Recordset.lastModified
    AbilitaCampiEPulsanti (False)
End With
End Sub

Public Sub OrdinaRecord(OrdinaPer As Integer)
    SqlInfos.Ordine = F_Principale.D_Infos.Recordset.Fields(OrdinaPer).Name
    Call RefreshRecord
End Sub

Public Sub RefreshRecord()
Dim SqlString As String
SqlString = "SELECT " & SqlInfos.Campi & " FROM Infos" & _
        IIf(SqlInfos.Requisiti <> "", " WHERE " & SqlInfos.Requisiti, "") & _
        IIf(SqlInfos.Ordine <> "", " ORDER BY [" & SqlInfos.Ordine & "]", "")

    F_Principale.D_Infos.RecordSource = SqlString
    F_Principale.D_Infos.Refresh
End Sub

Public Function SetDatabase(tempFileName As String) As Boolean
'Setta un nuovo file
If tempFileName <> "" Then
    On Error GoTo err_Set
    F_Principale.D_Infos.DatabaseName = tempFileName
    F_Principale.D_Infos.Refresh
    fileName = tempFileName
    SetDatabase = True
End If
Exit Function
err_Set:
If fileName <> "" Then
    D_Infos.DatabaseName = fileName
    D_Infos.Refresh
End If
End Function

Public Function AskNewDatabase() As Boolean
Dim tempFile As String
tempFile = saveFileEasy(Richieste(0), "Files Program Manager (*.pmf)|*.pmf", fileName)
If Trim(tempFile) = "" Then Exit Function

If NuovaCompilation(tempFile) Then
    fileName = tempFile
    F_Principale.D_Infos.DatabaseName = fileName
    F_Principale.D_Infos.Refresh
    AskNewDatabase = True
End If

End Function

Public Function AskOpenDatabase() As Boolean
'Apre un nuovo file
Dim tempFile As String
tempFile = openFileEasy(Richieste(2), "Files Program Manager (*.pmf)|*.pmf", fileName)
AskOpenDatabase = SetDatabase(tempFile)

End Function
'********************************************************************
'               Funzioni di utilit
'********************************************************************

Private Sub AbilitaCampiEPulsanti(Abilita As Boolean)
With F_Principale
    For i = 0 To 4
        .T_PrEditor(i).Locked = Not Abilita
    Next i
    'Colori
    If Abilita Then
        .T_PrEditor(0).BackColor = &HFF
        .T_PrEditor(2).BackColor = &HFF
    Else
        .T_PrEditor(0).BackColor = &H80000005
        .T_PrEditor(2).BackColor = &H80000005
    End If
    .M_Comandi.Enabled = Not Abilita
    .Frame_Menu.Enabled = Not Abilita
    .Fr_Add.Visible = Abilita
    .Grid_Programmi.Enabled = Not Abilita
End With
End Sub

Private Sub RipulisciCampi()
For i = 0 To 4
    F_Principale.T_PrEditor(i).Text = ""
Next i
End Sub

Public Function CreateNewDatabase(DbFileName As String) As Boolean
'Crea un nuovo Database vuoto nel percorso indicato
'Per farlo devo:
'1) Creare un nuovo file
'2) Creare una tabella nel file
'3) Specificare i campi della tabella
On Error GoTo Gestione_Errori

Dim dbData As Database
Dim dtTable As TableDef
Dim diIndex As Index
Dim dfField As Field
Dim iItems As Integer

'1) Distruggo quello precedente un nuovo file
RimuoviFile (DbFileName)
Set dbData = DBEngine.CreateDatabase(DbFileName, dbLangGeneral, dbVersion30)

'2) Creare una tabella nel file
Set dtTable = dbData.CreateTableDef("Infos")


' Crea Indice per la tabella
'Set diIndex = dtTable.CreateIndex("Nome Programma")
'Set dfField = diIndex.CreateField("Nome Programma", dbText, 255)

'With diIndex
'    .Required = True
'    .Unique = False
'    .Primary = True
'    .Fields.Append dfField
'End With
'dtTable.Indexes.Append diIndex

'3) Specificare i campi della tabella
Set dfField = dtTable.CreateField("Nome Programma", dbText, 30)
With dfField
    .Attributes = dbVariableField
    '.Unique = False
    .Required = True
End With
dtTable.Fields.Append dfField

Set dfField = dtTable.CreateField("Versione", dbText, 20)
With dfField
    .Attributes = dbVariableField
    '.Unique = False
    .Required = False
End With
dtTable.Fields.Append dfField

Set dfField = dtTable.CreateField("Nome Disco", dbText, 25)
With dfField
    .Attributes = dbVariableField
    '.Unique = False
    .Required = True
End With
dtTable.Fields.Append dfField

Set dfField = dtTable.CreateField("Informazioni", dbText, 255)
With dfField
    .Attributes = dbVariableField
    '.Unique = False
    .Required = False
End With
dtTable.Fields.Append dfField

Set dfField = dtTable.CreateField("Percorso", dbText, 255)
With dfField
    .Attributes = dbVariableField
    '.Unique = False
    .Required = False
End With
dtTable.Fields.Append dfField



'4) Attacco la tabella creata al file

dbData.TableDefs.Append dtTable


'Cancello le informazioni in memoria
Set dtTable = Nothing
Set diIndex = Nothing
Set dfField = Nothing
Set dbData = Nothing

'OK Finito
CreateNewDatabase = True
Exit Function

' Errori in fase di creazione
Gestione_Errori:
'Aggiunto codice per intrappolare gli errori
CreateNewDatabase = False
End Function

Public Sub SetNomeCampi()
Dim d As Integer
F_Search.Comb_Campo.Clear
For d = 0 To 4
    'F_Principale.Lab(d).Caption = NomeCampo(d)
    F_Principale.Grid_Programmi.Columns(d).Caption = F_Principale.Lab(d).Caption
    F_Principale.Cm_Menu_Ordina(d).Caption = F_Principale.Lab(d).Caption
    F_Search.Comb_Campo.AddItem (F_Principale.Lab(d).Caption)
    F_Opzioni.Ch_Campo(d).Caption = F_Principale.Lab(d).Caption
Next d
End Sub

Private Function getValueFromConsString(strWithZerosOrWhites As String) As String
Dim Pos As Long
Dim d As Integer

Pos = InStr(1, strWithZerosOrWhites, Chr(0))
If Pos > 0 Then
    getValueFromConsString = Left(strWithZerosOrWhites, Pos - 1)
Else
    getValueFromConsString = RTrim(strWithZerosOrWhites)
End If
End Function
'********************************************************************
'               Main e Altre
'********************************************************************

Public Sub TerminateProgram()
Dim d As Integer
F_Principale.D_Infos.Database.Close

'Dati Da salvare
'Opzioni
Call setIniVal(InfoFile, "Options", "LastFile", fileName)
For d = 0 To 4
    Call setIniVal(InfoFile, "Options", "Campo" & CStr(d), F_Opzioni.Ch_Campo(d).Value)
    Call setIniVal(InfoFile, "Options", "NomiCampi" & CStr(d), F_Opzioni.T_NomeCampoSpEsporta(d).Text)
    Call setIniVal(InfoFile, "Options", "Opzione" & CStr(d), F_Opzioni.Ch_Opzioni(d).Value)
Next d
Call setIniVal(InfoFile, "Options", "Intestazione", F_Opzioni.T_EsportaTop.Text)
Call setIniVal(InfoFile, "Options", "MaxRecurse", F_Opzioni.T_MaxRicorsione.Text)
'Testo inizio per HTML
Dim myArray() As String
ReDim myArray(-1 To -1)
Call TestoToArray(F_Opzioni.T_HtmlHead.Text, myArray)
Call setIniSection(InfoFile, "HtmlHead", "")
For d = 0 To UBound(myArray)
    If myArray(d) = "" Then myArray(d) = "#VUOTO#"
    Call setIniVal(InfoFile, "HtmlHead", "Line" & CStr(d), myArray(d))
Next d

'Stampa
Call setIniVal(InfoFile, "Printer", "FontName", MyCommonDialog.Font.Name)
Call setIniVal(InfoFile, "Printer", "FontSize", MyCommonDialog.Font.Size)
Call setIniVal(InfoFile, "Printer", "FontBold", MyCommonDialog.Font.Bold)
Call setIniVal(InfoFile, "Printer", "FontItalic", MyCommonDialog.Font.Italic)

'Finestre da Chiudere
Unload F_Opzioni
Unload F_Search
Unload F_Principale
End
End Sub

Private Sub TestoToArray(ByVal Testo As String, myArray() As String)
Dim a As Long

If Testo = "" Then Exit Sub

b = LBound(myArray)
c = UBound(myArray)

a = InStr(1, Testo, vbCrLf)
Do While (a > 0)
    c = c + 1
    ReDim Preserve myArray(b To c)
    myArray(c) = Left(Testo, a - 1)
    Testo = Right(Testo, Len(Testo) - a - 1)
    a = InStr(1, Testo, vbCrLf)
Loop
c = c + 1
ReDim Preserve myArray(b To c)
myArray(c) = Testo

End Sub

Private Sub Main()
Dim Linguaggio As String
On Error Resume Next

Call SetLinguaggioDiDefault
Set MyCommonDialog = New BGSCommonDialog
Load F_Search
MyCommonDialog.SetForm F_Search

InfoFile = App.Path & "\ProgramManager.ini"
fileName = getIniString(InfoFile, "Options", "LastFile")
Linguaggio = getIniString(InfoFile, "Options", "Language")

If Linguaggio <> "" Then Call SetStrings(Linguaggio)

If Command <> "" And existFile(Command) Then
    If Not SetDatabase(Command) Then Call MsgBox(Errors(9), vbCritical): GoSub OpenExistent
Else
    GoSub OpenExistent
End If

Load F_Principale
Load F_Opzioni
Call MyCommonDialog.SetForm(F_Principale)

'Dati Da Caricare
MyCommonDialog.Font.Name = getIniString(InfoFile, "Printer", "FontName", , "Arial")
MyCommonDialog.Font.Size = CCur(getIniString(InfoFile, "Printer", "FontSize", , CStr(MyCommonDialog.Font.Size)))
MyCommonDialog.Font.Bold = CBool(getIniString(InfoFile, "Printer", "FontBold", , CStr(MyCommonDialog.Font.Bold)))
MyCommonDialog.Font.Italic = CBool(getIniString(InfoFile, "Printer", "FontItalic", , CStr(MyCommonDialog.Font.Italic)))

'Opzioni
For d = 0 To 4
    F_Opzioni.Ch_Campo(d).Value = CInt(getIniString(InfoFile, "Options", "Campo" & CStr(d), , "1"))
    F_Opzioni.T_NomeCampoSpEsporta(d).Text = getIniString(InfoFile, "Options", "NomiCampi" & CStr(d), , F_Opzioni.T_NomeCampoSpEsporta(d).Text)
    F_Opzioni.Ch_Opzioni(d).Value = CInt(getIniString(InfoFile, "Options", "Opzione" & CStr(d), , "0"))
Next d
'Testo inizio per HTML
Dim trovato As Boolean
tempStr = getIniString(InfoFile, "HtmlHead", "Line0", trovato)
If trovato Then F_Opzioni.T_HtmlHead.Text = ""
d = 1
Do While (trovato)
    F_Opzioni.T_HtmlHead.Text = F_Opzioni.T_HtmlHead.Text & IIf(tempStr <> "#VUOTO#", tempStr, "") & vbCrLf
    tempStr = getIniString(InfoFile, "HtmlHead", "Line" & CStr(d), trovato)
    d = d + 1
Loop

F_Opzioni.T_HtmlHead.Text = RTrim(F_Opzioni.T_HtmlHead.Text)

F_Opzioni.T_EsportaTop.Text = getIniString(InfoFile, "Options", "Intestazione", , F_Opzioni.T_EsportaTop.Text)
F_Opzioni.T_MaxRicorsione.Text = getIniString(InfoFile, "Options", "MaxRecurse", , F_Opzioni.T_MaxRicorsione.Text)


Call AbilitaCampiEPulsanti(False)
Set F_Opzioni.Lab(11).Font = MyCommonDialog.Font

If Linguaggio <> "" Then Call ChangeLanguage(Linguaggio)

Call SetNomeCampi
F_Principale.Show

Exit Sub
OpenExistent:
    Dim ok As Boolean
    Dim tempAns As VbMsgBoxResult
    'Chiedo di creare un nuovo database fino a quando accetta oppure esco
    Do While Not AskOpenDatabase()
        tempAns = MsgBox(Errors(11), vbInformation + vbYesNoCancel)
        If tempAns = vbCancel Then
            End
        ElseIf tempAns = vbYes Then
            GoTo OpenNew
        End If
    Loop
Return

OpenNew:
    'Chiedo di creare un nuovo database fino a quando accetta oppure esco
    Do While Not AskNewDatabase()
        tempAns = MsgBox(Errors(11), vbInformation + vbYesNoCancel)
        If tempAns = vbCancel Then
            End
        ElseIf tempAns = vbNo Then
            GoTo OpenExistent
        End If
    Loop
Return
End Sub
