VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "PrinterCls"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'*********************************************************************
'Titolo: PrinterCls.cls
'Autore: Giorgio Bernardi
'E-Mail: BGSoftware@hotmail.com
'Data  : Febbraio 2001
'Descrizione: Questo Modulo serve per gestire la stampa di testi TXT
'Info:  Potete usare e modificare a piacimento questo codice
'*********************************************************************
Option Explicit

'**************************************************************************
'Tipi
'**************************************************************************
Public Enum AlignementPrinterClsConstant
    AlignLeft
    AlignRight
    AlignCenter
    AlignGiustificato
End Enum

Public Enum ScalaMarginiPrinterClsConstant
    'vbUser = 0          'Indica che una o pi propriet ScaleHeight, ScaleWidth, ScaleLeft e ScaleTop sono impostate su valori personalizzati.
    vbTwips = 1         '(Predefinita) Twip (1440 twip per pollice logico; 567 twip per centimetro logico).
    vbPoints = 2        'Punti (72 punti per pollice logico).
    'vbPixels = 3        'Pixel (unit di misura minima per la risoluzione di un monitor o di una stampante).
    vbCharacters = 4    'Caratteri (orizzontale = 120 twip per unit; verticale = 240 twip per unit).
    vbInches = 5        'Pollici.
    vbMillimeters = 6   'Millimetri.
    vbCentimeters = 7   'Centimetri.
End Enum

Public Enum InterlineaPrinterClsConstant
    Singola = 1
    Doppia = 2
    Tripla = 3
End Enum

Private Const C_SPACE = " "
Private Const C_CHAR = "A"      'Mi serve per l'altezza del carattere

'Costanti Cancellabili se non si vogliono visualizzare i
'Dialoghi per la stampa
Private Const cdlPDAllPages = &H0           'Imposta come Default la stampa di tutte le pagine
'Private Const cdlPDCollate = &H10           'Imposta come Default la stampa di pi copie in Fascicoli
Private Const cdlPDDisablePrintToFile = &H80000 'Disabilita Stampa su File
'Private Const cdlPDHelpButton = &H800       'Help Button
Private Const cdlPDHidePrintToFile = &H100000 'Nasconde Stampa Su File
Private Const cdlPDNoPageNums = &H8         'Disabilita il Bottone "Da Pagina A Pagina"
Private Const cdlPDNoSelection = &H4        'Disabilita il Bottone "Stampa Selezione"
Private Const cdlPDNoWarning = &H80         'Messaggio se non c' stampante predefinita
Private Const cdlPDPageNums = &H2           'Stato di Pages option button.
'Private Const cdlPDPrintSetup = &H40        'Fa vedere il Print Setup Dialog Box al posto del Print normale
'Private Const cdlPDPrintToFile = &H20       'Stato del Bottone Print To File
'Private Const cdlPDReturnDC = &H100         'Returns a device context for the printer selection made in the dialog box. The device context is returned in the dialog box's hDC property.
'Private Const cdlPDReturnDefault = &H400    'Restituisce il Nome della stampante predefinita
'Private Const cdlPDReturnIC = &H200         'Returns an information context for the printer selection made in the dialog box. An information context provides a fast way to get information about the device without creating a device context. The information context is returned in the dialog box's hDC property.
'Private Const cdlPDSelection = &H1          'Stato di Selection option button. If neither cdlPDPageNums nor cdlPDSelection is specified, the All option button is in the selected state.
Private Const cdlPDUseDevModeCopies = &H40000 'If a printer driver doesn't support multiple copies, setting this flag disables the copies edit control. If a driver does support multiple copies, setting this flag indicates that the dialog box stores the requested number of copies in the Copies property.

Private Type DEVMODE
    dmDeviceName As String * 32
    dmSpecVersion As Integer
    dmDriverVersion As Integer
    dmSize As Integer
    dmDriverExtra As Integer
    dmFields As Long
    dmOrientation As Integer
    dmPaperSize As Integer
    dmPaperLength As Integer
    dmPaperWidth As Integer
    dmScale As Integer
    dmCopies As Integer
    dmDefaultSource As Integer
    dmPrintQuality As Integer
    dmColor As Integer
    dmDuplex As Integer
    dmYResolution As Integer
    dmTTOption As Integer
    dmCollate As Integer
    dmFormName As String * 32
    dmUnusedPadding As Integer
    dmBitsPerPel As Integer
    dmPelsWidth As Long
    dmPelsHeight As Long
    dmDisplayFlags As Long
    dmDisplayFreq As Long
End Type

Private Type PRINTDLGSTRUC
    lStructSize As Long
    hWnd As Long
    hDevMode As Long
    hDevNames As Long
    hDC As Long
    Flags As Long
    nFromPage As Integer
    nToPage As Integer
    nMinPage As Integer
    nMaxPage As Integer
    nCopies As Integer
    hInstance As Long
    lCustData As Long
    lpfnPrintHook As Long
    lpfnSetupHook As Long
    lpPrintTemplateName As String
    lpSetupTemplateName As String
    hPrintTemplate As Long
    hSetupTemplate As Long
End Type

'Public Enum prntOrientation
'    cdlPortrait = 1
'    cdlLandscape = 2
'End Enum

Private Declare Function PrintDlg Lib "comdlg32.dll" Alias "PrintDlgA" (pPrintdlg As PRINTDLGSTRUC) As Long
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)

'Variabili Cancellabili se non interessa la gestione del setup di stampa
Private Flags As Double


'**************************************************************************
'Variabili Pubbliche (Propriet dell'oggetto)
'**************************************************************************
Public LeftMargin As Single
Public RightMargin As Single
Public TopMargin As Single
Public DownMargin As Single
Public Interlinea As InterlineaPrinterClsConstant
Public Font As New StdFont
Public Align As AlignementPrinterClsConstant
Public ScalaMargini As ScalaMarginiPrinterClsConstant
Public DoNotGiustifyLastLine As Boolean
Public ForeColor As Long
Public Tag As String
Public Copies As Integer
Public Orientation As prntOrientation
Public ChoosenPrinter As Printer

'**************************************************************************
'Variabili Private
'**************************************************************************
Private LeftMarginTwip As Single      'Io uso Questi valori privati
Private RightMarginTwip As Single
Private TopMarginTwip As Single
Private DownMarginTwip As Single
Private MaxTextWidth As Single
Private MaxTextHeight As Single


Private righestampate As Integer



Private PrintTo As Object           'Identifica la periferica di stampa
'Private AnteprimaClass As AnteprimaCls
Private StampanteReale As Boolean   'Indica se la periferica  una vera stampante
                                    'Serve per NewPage!
Private Anteprima As Boolean        'Serve per NewPage!
Private DocumentSpooling As Boolean 'Mi dice se sto stampando qualcosa
Private UsaLastTopMargin As Boolean
Private GiaStampato As Boolean      'Mi indica se ho gi un TopMargin corretto in memoria

'**************************************************************************
'Funzioni e Procedure Richiamabili (METODI) (Per Stampante)
'**************************************************************************
Public Function PrintText(ByRef Text As String) As Boolean
    If Not DocumentStart Then Exit Function
    
    PrintText = DocumentPrintText(Text, False)
    Call DocumentEnd
End Function

Public Function PrintPicture(ByRef Image As StdPicture, Optional UsaAllineamento As Boolean = True) As Boolean
    If Not DocumentStart Then Exit Function
    
    PrintPicture = DocumentPrintPicture(Image, False, UsaAllineamento)
    Call DocumentEnd
End Function

Public Function DocumentStart() As Boolean
'Controllo
    If DocumentSpooling Then Exit Function Else DocumentStart = True
    
    righestampate = 0
    
    GiaStampato = False
    DocumentSpooling = True
    StampanteReale = True
    Printer.Orientation = Orientation
    Printer.Copies = Copies
    Set PrintTo = Printer
    PrintTo.Orientation = Orientation
    PrintTo.Copies = Copies
End Function

Public Function GetNextPage(ByRef Text As String, ByVal StartChar As Long, ByRef LastChar As Long, Optional CalcolaSpazioRimastoNelFoglioCorrente As Boolean = True) As Boolean
    If Not DocumentSpooling Then
        StampanteReale = True
        Set PrintTo = Printer
        PrintTo.Orientation = Orientation
    End If
    UsaLastTopMargin = CalcolaSpazioRimastoNelFoglioCorrente And GiaStampato
    Call CalcolaMargini
    Call PreparaStampante
    'If UsaLastTopMargin Then TopMarginTwip = PrintTo.CurrentY
    GetNextPage = GetNextPageH(Text, StartChar, LastChar, PrintTo.CurrentY, MaxTextHeight)
End Function

'**************************************************************************
'Funzioni e Procedure Richiamabili (METODI) (Per Picture e/o Printer)
'**************************************************************************
Public Function DocumentPrintText(ByRef Text As String, Optional StampaSottoIlPrecedente As Boolean = True) As Boolean
'Controllo
    If Not DocumentSpooling Then Exit Function Else DocumentPrintText = True
    
    UsaLastTopMargin = StampaSottoIlPrecedente And GiaStampato
    Call CalcolaMargini
    Call PreparaStampante
    Call StampaTesto(Text)
    GiaStampato = True
End Function

Public Function DocumentPrintPicture(ByRef Image As StdPicture, Optional StampaSottoIlPrecedente As Boolean = True, Optional UsaAllineamento As Boolean = True) As Boolean
'Controllo
    If Not DocumentSpooling Then Exit Function Else DocumentPrintPicture = True
    
    UsaLastTopMargin = StampaSottoIlPrecedente And GiaStampato
    Call CalcolaMargini
    Call PreparaStampante
    Call StampaImmagine(Image, UsaAllineamento)
    GiaStampato = True
End Function

Public Function DocumentNewPage() As Boolean
'Controllo
    If Not DocumentSpooling Or Not (StampanteReale Or Anteprima) Then Exit Function Else DocumentNewPage = True
    
    GiaStampato = False
    If StampanteReale Then
        PrintTo.NewPage
    'Else
    '    AnteprimaClass.NewPage
    End If
End Function

Public Function ScaleX(Width As Single, Optional FromScale As Variant, Optional ToScale As Variant) As Single
    If Not DocumentSpooling Then Exit Function Else ScaleX = True
    ScaleX = PrintTo.ScaleX(Width, FromScale, ToScale)
End Function

Public Function ScaleY(Height As Single, Optional FromScale As Variant, Optional ToScale As Variant) As Single
    If Not DocumentSpooling Then Exit Function Else ScaleY = True
    ScaleY = PrintTo.ScaleY(Height, FromScale, ToScale)
End Function

Public Function TextHeight(Str As String) As Single
    If Not DocumentSpooling Then TextHeight = -1 Else TextHeight = PrintTo.TextHeight(Str)
End Function

Public Function TextWidth(Str As String) As Single
    If Not DocumentSpooling Then TextWidth = -1 Else TextWidth = PrintTo.TextWidth(Str)
End Function

Public Property Get ScaleHeight() As Single
    If Not DocumentSpooling Then ScaleHeight = -1 Else ScaleHeight = PrintTo.ScaleHeight
End Property

Public Property Get ScaleWidth() As Single
    If Not DocumentSpooling Then ScaleWidth = -1 Else ScaleWidth = PrintTo.ScaleWidth
End Property

Public Property Get ScaleMode() As Single
    If Not DocumentSpooling Then ScaleMode = -1 Else ScaleMode = PrintTo.ScaleMode
End Property

Public Function DocumentEnd() As Boolean
'Controllo
    If Not DocumentSpooling Then Exit Function Else DocumentEnd = True

    GiaStampato = False
    DocumentSpooling = False
    If StampanteReale Then
        PrintTo.EndDoc
    'ElseIf Anteprima Then
    '    AnteprimaClass.EndDoc
    End If
End Function
'**************************************************************************
'Funzioni e Procedure Richiamabili (METODI) (Per Picture)
'**************************************************************************
Public Function PrintTextToObject(ByRef Text As String, Destination As Object) As Boolean
    If Not DocumentStartToObject(Destination) Then Exit Function
    
    Call DocumentPrintText(Text, False)
    Call DocumentEnd
    PrintTextToObject = True
End Function

Public Function PrintPictureToObject(ByRef Image As StdPicture, Destination As Object, Optional UsaAllineamento As Boolean = True) As Boolean
    If Not DocumentStartToObject(Destination) Then Exit Function
    
    Call DocumentPrintPicture(Image, False, UsaAllineamento)
    Call DocumentEnd
    PrintPictureToObject = True
End Function

Public Function DocumentStartToObject(Destination As Object) As Boolean
'Controllo
    If DocumentSpooling Then Exit Function Else DocumentStartToObject = True
    
    GiaStampato = False
    DocumentSpooling = True
    StampanteReale = False
    Set PrintTo = Destination
End Function

Public Function GetNextPageForObject(ByRef Text As String, ByVal StartChar As Long, ByRef LastChar As Long, Destination As Object) As Boolean
    StampanteReale = False
    If Not DocumentSpooling Then Set PrintTo = Destination
    Call CalcolaMargini
    Call PreparaStampante
    GetNextPageForObject = GetNextPageH(Text, StartChar, LastChar, PrintTo.CurrentY, MaxTextHeight)
End Function


Public Function ChoosePrinterOptions() As Boolean
    'Chiede quale stampante usare e quante copie
    Flags = cdlPDNoPageNums Or cdlPDHidePrintToFile Or cdlPDNoSelection Or cdlPDPageNums Or cdlPDUseDevModeCopies
    ChoosePrinterOptions = ShowPrintH(0)
End Function

'**************************************************************************
'Funzioni e Procedure Utili
'**************************************************************************
Private Function GetNextPageH(ByRef Text As String, ByVal StartChar As Long, ByRef LastChar As Long, ByRef StartFromY As Single, ByRef EndToY As Single) As Boolean
Dim ParagrafoCorrente As String
Dim InizioRiga As Long
Dim FineRiga As Long
Dim FineParagrafo As Long

Dim NumeroRigheStampabili As Long
Dim Pos As Long
Dim LastOkPos As Long

'Controlli
If Len(Text) < StartChar Then
    GetNextPageH = False
    LastChar = 0
    Exit Function
End If

'Parto a contare da StartChar
InizioRiga = StartChar
LastChar = StartChar
NumeroRigheStampabili = (EndToY - StartFromY) \ PrintTo.TextHeight(C_CHAR)
'NumeroRigheStampabili = (EndToY - StartFromY) \ Printer.TextHeight(C_CHAR)
If PrintTo.ScaleWidth - LeftMarginTwip - RightMarginTwip < PrintTo.TextWidth(C_SPACE) Or _
    (EndToY - StartFromY) < PrintTo.TextHeight(C_CHAR) Then Exit Function

Do
    FineParagrafo = InStr(InizioRiga, Text, vbCrLf)
    If FineParagrafo = 0 Then FineParagrafo = Len(Text)
    
    'Ora ho il paragrafo, vedo le righe
    Do While (FineParagrafo >= InizioRiga) And (NumeroRigheStampabili > 0)

    If PrintTo.TextWidth(Mid(Text, InizioRiga, FineParagrafo - InizioRiga)) < MaxTextWidth Then
        LastChar = FineParagrafo
        NumeroRigheStampabili = NumeroRigheStampabili - Me.Interlinea
        Exit Do
    Else
        Pos = InizioRiga - 1
        LastOkPos = InizioRiga
        Do
            Pos = InStr(Pos + 1, Text, C_SPACE)
                        
            If Pos = 0 Then GoTo NoSpace
            If (PrintTo.TextWidth(Mid(Text, InizioRiga, Pos - InizioRiga)) > MaxTextWidth) Or (Pos > FineParagrafo) Then
NoSpace:
                If LastOkPos = InizioRiga Then  'Significa che c' una parola pi lunga della riga di stampa!
                    Do
                        LastOkPos = LastOkPos + 1
                    Loop While PrintTo.TextWidth(Mid(Text, InizioRiga, LastOkPos - InizioRiga)) <= MaxTextWidth
                End If
                
                If LastOkPos <= InizioRiga Then Exit Function 'Non ci sta neppure una lettera nei margini indicati!
                
                NumeroRigheStampabili = NumeroRigheStampabili - Me.Interlinea
                
                If Mid(Text, LastOkPos, 1) = C_SPACE Then
                    InizioRiga = LastOkPos + 1
                Else
                    InizioRiga = LastOkPos
                End If
                LastChar = LastOkPos
                
                Exit Do
            Else
                LastOkPos = Pos
            End If
        Loop
    End If
    Loop

    InizioRiga = FineParagrafo + 2

    If Len(Text) < InizioRiga Then Exit Do
Loop While (NumeroRigheStampabili > 0)

If Mid(Text, LastChar, 1) = vbCr And Mid(Text, LastChar + 1, 1) = vbLf Then _
    LastChar = LastChar + 1

GetNextPageH = True

End Function

'**************************************************************************
'Funzioni Private
'**************************************************************************
Private Function ShowPrintH(hWnd As Long) As Boolean
Dim DM As DEVMODE
Dim PD As PRINTDLGSTRUC
Dim lpDM As Long

PD.lStructSize = Len(PD)
PD.hWnd = hWnd
PD.hDevMode = 0
PD.hDevNames = 0
PD.hDC = 0
PD.Flags = Flags
PD.nFromPage = 0 'FromPage
PD.nToPage = 0 'ToPage
PD.nMinPage = 0 'Min
PD.nMaxPage = 0 'Max
PD.nCopies = 0 'Copies

If PrintDlg(PD) Then
    lpDM = GlobalLock(PD.hDevMode)
    CopyMemory DM, ByVal lpDM, Len(DM)
    lpDM = GlobalUnlock(PD.hDevMode)
    
    Dim PrinterName As String
    Dim X As Printer
    PrinterName = Left$(DM.dmDeviceName, InStr(DM.dmDeviceName, Chr(0)) - 1)
    For Each X In Printers
        If X.DeviceName = PrinterName Then
            Set Printer = X
            Exit For
        End If
    Next
    
    'Valori Di Default
    'PrintAll = True
    'PrintSelection = False
    'If PD.Flags And &H20 Then PrintToFile = True Else PrintToFile = False
    'If DM.dmCollate = 1 Then Collate = True Else Collate = False
    'If PD.Flags And &H2 Then
    '    PrintAll = False
    '    PrintSelection = False
    '    FromPage = PD.nFromPage
    '    ToPage = PD.nToPage
    'End If
    'If PD.Flags And &H1 Then
    '    PrintAll = False
    '    PrintSelection = True
    'End If
    Copies = DM.dmCopies
    Orientation = DM.dmOrientation
    ShowPrintH = True
Else
    ShowPrintH = False
End If
End Function

Private Sub StampaImmagine(ByRef Immagine As StdPicture, UseAlignment As Boolean)
On Error Resume Next
If UseAlignment Then
    Select Case Align
    Case AlignRight
        PrintTo.CurrentX = PrintTo.ScaleWidth - RightMarginTwip - PrintTo.ScaleX(Immagine.Width)
    Case AlignCenter
        PrintTo.CurrentX = (MaxTextWidth - PrintTo.ScaleX(Immagine.Width)) \ 2 + LeftMarginTwip
    Case Else
        PrintTo.CurrentX = LeftMarginTwip
    End Select
Else
        PrintTo.CurrentX = LeftMarginTwip
End If

Call PrintTo.PaintPicture(Immagine, PrintTo.CurrentX, PrintTo.CurrentY)
PrintTo.CurrentY = PrintTo.CurrentY + PrintTo.ScaleY(Immagine.Height) '+ .TextHeight(C_CHAR)
End Sub

Private Sub StampaTesto(ByRef Text As String)
Dim ParagrafoCorrente As String
Dim FineRiga As Long
Dim InizioRiga As Long

InizioRiga = 1
If PrintTo.ScaleWidth - LeftMarginTwip - RightMarginTwip < PrintTo.TextWidth(C_SPACE) Or _
    PrintTo.ScaleHeight - TopMarginTwip - DownMarginTwip < PrintTo.TextHeight(C_CHAR) Then Exit Sub
    
Do
    FineRiga = InStr(InizioRiga, Text, vbCrLf)
    If FineRiga = 0 Then
        ParagrafoCorrente = IIf(InizioRiga = 1, Text, Right(Text, Len(Text) - InizioRiga + 1))
    Else
        ParagrafoCorrente = IIf(InizioRiga = 1, Left(Text, FineRiga - 1), Mid(Text, InizioRiga, FineRiga - InizioRiga))
    End If
    
    Call StampaParagrafo(ParagrafoCorrente)
    InizioRiga = FineRiga + 2
    If Len(Text) < InizioRiga Then Exit Do
Loop While FineRiga <> 0
        
End Sub

Private Sub StampaParagrafo(ByRef Paragrafo As String)
'Questa procedura trasforma un paragrafo (* & vbcrlf) in "righe",
'ovvero stringhe lunghe al massimo quanto pu starci nella riga di
'una pagina di stampante
Dim Riga() As String
Dim Pos As Long
Dim LastOkPos As Long

ReDim Riga(0 To 0)

Do
    If PrintTo.TextWidth(Paragrafo) < MaxTextWidth Then
        Call AddToArray(Riga, Paragrafo)
        Exit Do
    Else
        Do
            Pos = InStr(Pos + 1, Paragrafo, C_SPACE)
            
            If Pos = 0 Then GoTo NoSpace
            If PrintTo.TextWidth(Left(Paragrafo, Pos - 1)) > MaxTextWidth Then
NoSpace:
                If LastOkPos = 0 Then  'Significa che c' una parola pi lunga della riga di stampa!
                    Do
                        LastOkPos = LastOkPos + 1
                    Loop While PrintTo.TextWidth(Left(Paragrafo, LastOkPos)) <= MaxTextWidth
                End If
                
                If LastOkPos <= 1 Then Exit Sub 'Non ci sta neppure una lettera nei margini indicati!
                
                Call AddToArray(Riga, Left(Paragrafo, LastOkPos - 1))
                
                If Mid(Paragrafo, LastOkPos, 1) = C_SPACE Then
                    Paragrafo = Right(Paragrafo, Len(Paragrafo) - LastOkPos)
                Else
                    Paragrafo = Right(Paragrafo, Len(Paragrafo) - LastOkPos + 1)
                End If
                LastOkPos = 0
                Pos = 0
                Exit Do
            Else
                LastOkPos = Pos
            End If
        Loop
    End If
Loop

Dim d As Integer

For d = 1 To UBound(Riga)
    Call StampaRiga(Riga(d), CBool(d = UBound(Riga)))
Next d

End Sub

Private Sub StampaRiga(ByRef Riga As String, Optional LastLine As Boolean)
With PrintTo
    'Vedo se devo creare una nuova pagina
    'se  una stampante reale
    If (StampanteReale Or Anteprima) And .CurrentY + .TextHeight(Riga) > MaxTextHeight Then
        If StampanteReale Then
            .NewPage
        'Else
        '    AnteprimaClass.NewPage
        End If
        
        righestampate = 0
        
        .CurrentY = TopMarginTwip
    End If
    
    Select Case Align
        Case AlignLeft
            .CurrentX = LeftMarginTwip
        Case AlignRight
            .CurrentX = .ScaleWidth - RightMarginTwip - .TextWidth(Riga)
        Case AlignCenter
            .CurrentX = (MaxTextWidth - .TextWidth(Riga)) / 2 + LeftMarginTwip
        Case AlignGiustificato
            Dim Pos As Long
            Dim NumSpace As Long
            Dim NumSpaceDaMettere As Long
            Dim SpaceLenght As Long
            Dim SpacePerSpace As Long
            Dim d As Integer
            
            If Not (LastLine And DoNotGiustifyLastLine) Then
                'Vedo quanti spazi ci sono
                Pos = 0
                Do
                    Pos = InStr(Pos + 1, Riga, C_SPACE)
                    If Pos > 0 Then NumSpace = NumSpace + 1
                Loop While Pos <> 0
                
                If NumSpace > 0 Then 'Altrimenti non calcolo neppure
                    'Quanto misura uno spazio?
                    SpaceLenght = .TextWidth(C_SPACE)
                    'Quanti spazi devo aggiungere ? e quanti per ogni spazio?
                    NumSpaceDaMettere = (.ScaleWidth - LeftMarginTwip - RightMarginTwip - .TextWidth(Riga)) \ SpaceLenght
                    SpacePerSpace = NumSpaceDaMettere \ NumSpace
                    NumSpaceDaMettere = NumSpaceDaMettere Mod NumSpace
                    
                    For d = Len(Riga) To 1 Step -1
                        If Mid(Riga, d, 1) = C_SPACE Then
                            Riga = Left(Riga, d) & IIf(NumSpaceDaMettere > 0, C_SPACE, "") & Space(SpacePerSpace) & Right(Riga, Len(Riga) - d)
                            NumSpaceDaMettere = NumSpaceDaMettere - 1
                        End If
                    Next d
                End If
            End If
            .CurrentX = LeftMarginTwip
    End Select

'Ora sono pronto per scrivere
'PrintTo.Print Riga
righestampate = righestampate + 1
'PrintTo.Print CStr(righestampate) & C_SPACE & Riga
PrintTo.Print Riga
'Ora calcololo l'interlinea e lo spostamento in basso!
PrintTo.CurrentY = PrintTo.CurrentY + (Me.Interlinea - 1) * PrintTo.TextHeight(C_CHAR)

End With
End Sub

Private Sub PreparaStampante()
With PrintTo
    Set .Font = Font
    .ForeColor = ForeColor
    '.ScaleMode = vbTwips
    If Not UsaLastTopMargin Then .CurrentY = TopMarginTwip 'Else .CurrentY = .CurrentY + .TextHeight(C_CHAR)
    MaxTextWidth = .ScaleWidth - LeftMarginTwip - RightMarginTwip
    MaxTextHeight = .ScaleHeight - DownMarginTwip
End With
End Sub

Private Sub CalcolaMargini()
'Converte i margini in margini in Twips
Dim Fattore As Double

Select Case ScalaMargini
    Case vbTwips
        Fattore = 1
    Case vbPoints
        Fattore = 20
    'Case vbPixels
    '    Fattore
    Case vbCharacters
        Fattore = 120
    Case vbInches
        Fattore = 1440
    Case vbMillimeters
        Fattore = 56.7
    Case vbCentimeters
        Fattore = 567
End Select
    
LeftMarginTwip = CLng(Fattore * LeftMargin)
RightMarginTwip = CLng(Fattore * RightMargin)
If Not UsaLastTopMargin Then TopMarginTwip = CLng(Fattore * TopMargin)
DownMarginTwip = CLng(Fattore * DownMargin)

If ScalaMargini = vbCharacters Then
    'Per i caratteri il fattore verticale  doppio rispetto all'orizzontale
    If Not UsaLastTopMargin Then TopMarginTwip = TopMarginTwip * 2
    DownMarginTwip = DownMarginTwip * 2
End If

End Sub

'Private Sub AddToArray(strArray() As String, Elemento As String)
'Aggiunge un elemento all'array di stringhe
'On Error Resume Next
'Dim nextPos As Integer
'Dim leftPos As Integer

'nextPos = UBound(strArray) + 1
'leftPos = LBound(strArray)
'ReDim Preserve strArray(leftPos To nextPos)
'strArray(nextPos) = Elemento
'End Sub






Private Sub Class_Initialize()
DoNotGiustifyLastLine = True
Align = AlignLeft
Interlinea = Singola
Orientation = cdlPortrait
ScalaMargini = vbTwips

'ShowPrint: Ricavo i dati dalla stampante predefinita
Set ChoosenPrinter = Printer
Copies = ChoosenPrinter.Copies
ForeColor = ChoosenPrinter.ForeColor
Set Font = ChoosenPrinter.Font
End Sub
